function v = runLengthDecode(v_rle)
% This function is part of the MPI08 data set, to be obtained at 
% http://www.tnt.uni-hannover.de/project/MPI08_Database/
%
% Revision:   1.0
% Date:       28.09.2010
%
% Copyright 2010, MPI Informatik, Germany, and Hannover University, Germany.
% All Rights Reserved Permission to use, copy, modify, and distribute this
% software and its documentation for any non-commercial purpose is hereby
% granted without fee, provided that the above copyright notice appear in
% all copies and that both that copyright notice and this permission
% notice appear in supporting documentation, and that the name of the
% author not be used in advertising or publicity pertaining to distribution
% of the software without specific, written prior permission.
% THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
% INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR ANY
% PARTICULAR PURPOSE. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
% SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
% RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
% CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
% CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
% Assumption: every vector begins with a run of "1". (If not, => first run length is zero.)

if (~isa(v_rle,'double'))
    v_rle = double(v_rle);
end

if (size(v_rle,1)~=1)
    v_rle = v_rle';
end

n = sum(v_rle);
v = false(1,n);

runs_start = [1 cumsum(v_rle)+1];
ones_start = runs_start(1:2:end-1);
v_rle = v_rle(1:2:end);

for k=1:length(v_rle)
    v(ones_start(k):ones_start(k)+v_rle(k)-1) = ones(1,v_rle(k));
end

